import { ProposalDataContext } from '@agiliza/api/domain'
import { EnquadramentoApiModel, GeneroApiModel } from '@microcredito/client'

import { DomainAdapter, IdDescriptionMapper } from '../shared'

export interface DadosPropostaContexto {
  enquadramentos: EnquadramentoApiModel[]
  generos: GeneroApiModel[]
}

export class ContextMapper implements DomainAdapter<DadosPropostaContexto, ProposalDataContext> {
  private idDescriptionMapper: IdDescriptionMapper

  constructor() {
    this.idDescriptionMapper = new IdDescriptionMapper()
  }
  public mapApiModelToDomain = (dP: DadosPropostaContexto): ProposalDataContext => ({
    frameworks: dP.enquadramentos.map(this.idDescriptionMapper.mapApiModelToDomain),
    genders: dP.generos.map(this.idDescriptionMapper.mapApiModelToDomain),
  })
}
