import { IdDescricao } from '@agiliza/api/domain'
import { Entity } from '@agiliza/utils/method'

export interface DomainAdapter<A, B> {
  mapApiModelToDomain(apiModel: A): B
}

interface IdDescription extends Entity {
  description: string
}

export class IdDescriptionMapper implements DomainAdapter<IdDescricao, IdDescription> {
  public mapApiModelToDomain = (iD: IdDescricao): IdDescription => ({
    id: iD.id,
    description: iD.descricao,
  })
}
