import { normalize, schema } from 'normalizr'

import { ProposalDataContext } from '@agiliza/api/domain'
import { WithNormalizedEntity } from '@agiliza/utils/method'

export const PROPOSAL_DATA_PREFIX = 'entities/proposalData'

export type NormalizedContext = WithNormalizedEntity<ProposalDataContext>

const contextSchemas = new schema.Object({
  frameworks: new schema.Array(new schema.Entity('frameworks')),
  genders: new schema.Array(new schema.Entity('genders')),
})

export const normalizeContext = (context: ProposalDataContext) => {
  const { entities } = normalize(context, contextSchemas)
  const normalizedEntities = entities as unknown as NormalizedContext
  return normalizedEntities
}
