import { createAsyncReducers, getTypesThunkActions, values } from '@agiliza/utils/method'
import { createSlice } from '@reduxjs/toolkit'

const prefix = 'useCases/businessData'

export interface State {
  fetching: boolean
}

export const initialState: State = {
  fetching: false,
}

export const actions = {} as const
export const types = getTypesThunkActions(actions)

const login = createSlice({
  name: prefix,
  initialState,
  reducers: {},
  extraReducers: {
    ...values(types).reduce((reducers, type) => ({ ...reducers, ...createAsyncReducers(type) }), {}),
  },
})

export default login
