import React from 'react'

import { ActionType } from '@agiliza/utils/hooks/state'
import Address from '@agiliza/views/ProposalData/components/templates/Address'
import { withStyles, WithStyles } from '@material-ui/core/styles'

import { CustomerAddressState } from '../state'
import styles from './styles'

type ExtendedProps = WithStyles<typeof styles>

interface Props extends ExtendedProps {
  state: CustomerAddressState
  actions: ActionType<CustomerAddressState>
}

const Form = (props: Props) => {
  const { classes, state, actions } = props

  return (
    <form className={classes.form}>
      <Address state={state} onChange={(addrs) => actions.update(addrs)} />
    </form>
  )
}

export default withStyles(styles)(Form)
