import React from 'react'

import { useFormState } from '@agiliza/utils/hooks/state'
import { withStyles, WithStyles } from '@material-ui/core/styles'

import Form from './Form'
import { initialState } from './state'
import styles from './styles'

type ExtendedProps = WithStyles<typeof styles>

interface Props extends ExtendedProps {}

const SpouseData = (props: Props) => {
  const { classes } = props

  const formState = useFormState('spouseDataForm', initialState)
  return (
    <div className={classes.contentContainer}>
      <div className={classes.content}>
        <Form {...formState} />
      </div>
    </div>
  )
}

export default withStyles(styles)(SpouseData)
