import { connect } from 'react-redux'

import { StoreState } from '@agiliza/redux'
import * as ucProposalDataContext from '@agiliza/redux/useCases/proposalData/context'

export interface ConnectedProps {
  fetching: boolean
}

type StateProps = Pick<ConnectedProps, 'fetching'>
// type DispatchProps = Record<string, any>

const mapStateToProps = (state: StoreState): StateProps => ({
  fetching: ucProposalDataContext.selectors.isFetching(state.ui.login),
})

// const mapDispatchToProps = (dispatch: Dispatch): DispatchProps => bindActionCreators({}, dispatch)

export const connected = connect(mapStateToProps)
